Program UC; {UltraClip - a Clipboard Extender}
uses WObjects, WinTypes, WinProcs,Strings,Win31,ClipObj,Buttons,Sclptext;
{$R UC.RES}
{$D UltraClip - Copyright (c) 1992 by Doug Overmyer}
CONST
  AppName : PChar = 'UC';
  FrmName : PChar = 'UC';
  ChdName : PChar = 'UCChd';
  cm_Copy    = cm_EditCopy;     {menuitem EditCopy    }
  cm_Paste   = cm_EditPaste;    {menuitem EditPaste   }
  cm_Delete  = cm_EditDelete;
  cm_Cut     = cm_EditCut;
	um_ButtonU = 198;
  um_ButtonD = 199;
  id_But1    = 301;
  id_But2    = 302;
  id_But3    = 303;
  id_But4    = 304;
  id_But5    = 305;
  id_But6    = 306;
  id_ST1     = 401;
  id_D1RB1   = 451;
  id_D1RB2   = 452;
  id_D1EC1   = 453;
  cm_RunCB   = 500;
  cm_AutoPaste = 501;
  cm_ClipClear = 502;
  cm_Configure = 503;
  cm_IconAll   = 504;
  cm_RestoreAll = 505;
  cm_Exit    = 24340;     {menuitem FileExit    }
  idm_About  = 801;     {menuitem ABout       }
  idm_ClipBoard = 803;
  id_Timer   = 999;
  um_Copy    = cm_EditCopy;
  um_Delete  = cm_EditDelete;
  um_ChildExit =  901;
  um_ChildFocus = 902;
  um_GetSelf    = 903;
  id_ChildMenuPos = 2;
  IniFile = 'UC.INI';
type
TUCApp = OBJECT(TApplication)
	procedure InitMainWindow; Virtual;
end;

PUCBtn = ^TUCBtn;
TUCBtn = object(TODButton)
	constructor	Init(AParent:PWindowsObject; AnID:Integer;ATitle:PChar;
  	X1,Y1,W1,H1:Integer;IsDefault:Boolean;BMP:PChar;AGroup:PGroupBox);
  procedure WMRButtonDown(var Msg:TMessage);virtual wm_First+wm_RButtonDown;
  procedure WMRButtonUp(var Msg:TMessage);virtual wm_First+wm_RButtonUp;
end;

PUCStatic = ^TUCStatic;
TUCStatic = object(TSText)
	constructor Init(AParent:PWindowsObject;AnID:Integer; ATitle:PChar;
  	NewX,NewY,NewW,NewH:Integer; NewState,NewStyle:Integer);
	procedure WMRButtonDown(var Msg:TMessage);virtual wm_First+wm_RButtonDown;
end;

PUCWin = ^TUCWin;
TUCWin = OBJECT(TMDIWindow)
	BN:Array[0..6] of PUCBtn;
  ST1:PUCStatic;
	NextViewer:HWnd;
  IsAutoPaste:Boolean;
  Help:Array[0..50] of Char;
  Helv:HFont;
  ThumbNailSize:TRect;
	constructor Init(ATitle : PChar; AMenu : HMenu);
  destructor Done; Virtual;
  procedure SetupWindow; Virtual;
  function GetClassName : PChar; Virtual;
  procedure GetWindowClass(var AWndClass: TWndClass);Virtual;
  procedure InitClientWindow; Virtual;
  function InitChild : PWindowsObject; Virtual;
  procedure CMCut(var Msg:TMessage);virtual cm_First+cm_Cut;
  procedure CMCopy(var Msg:TMessage);virtual cm_First+cm_Copy;
  procedure CMPaste(var Msg:TMessage);virtual cm_First+cm_Paste;
  procedure CMDelete(var Msg:TMessage);virtual cm_First+cm_Delete;
	procedure CMAutoPaste(var Msg:TMessage);virtual cm_First+cm_AutoPaste;
  procedure CMClipClear(var Msg:TMessage);virtual cm_First+cm_ClipClear;
  procedure CMRunCB(var Msg:TMessage);virtual cm_First+cm_RunCB;
  procedure CMConfigure(var Msg:TMessage);virtual cm_First+cm_Configure;
  procedure WMChangeCBChain(var Msg:TMessage);virtual wm_First+wm_ChangeCBChain;
  procedure WMDrawClipBoard(var Msg:TMessage);virtual wm_First+wm_DrawClipBoard;
  procedure WMTimer(var Msg:TMessage);virtual wm_First+wm_Timer;
  procedure UMChildExit(var Msg:TMessage);virtual wm_User+um_ChildExit;
  procedure UMChildFocus(var Msg:TMessage);virtual wm_User+um_ChildFocus;
  procedure WMPaletteChanged(var Msg:TMessage);virtual wm_First+wm_PaletteChanged;
  procedure WMQueryNewPalette(var Msg:TMessage);virtual wm_first+wm_QueryNewPalette;
  procedure WMSize(var Msg:TMessage);virtual wm_First+wm_Size;
  procedure	WMDrawItem(var Msg:TMessage);virtual wm_First + wm_DrawItem;
  procedure UMRButtonDown(var Msg:TMessage);virtual wm_User+wm_RButtonDown;
  procedure DispInfo;
  procedure Paint(PaintDC:HDC;var PaintInfo:TPaintStruct);virtual;
  procedure IDBut1(var Msg:TMessage);virtual id_First+id_But1;
  procedure IDBut2(var Msg:TMessage);virtual id_First+id_But2;
  procedure IDBut3(var Msg:TMessage);virtual id_First+id_But3;
  procedure IDBut4(var Msg:TMessage);virtual id_First+id_But4;
  procedure IDBut5(var Msg:TMessage);virtual id_First+id_But5;
	procedure IDBut6(var Msg:TMessage);virtual id_First+id_But6;
  procedure WMSysCommand(var Msg:TMessage);virtual wm_First+wm_SysCommand;
  procedure CMIconAll(var Msg:TMessage);virtual cm_First+cm_IconAll;
  procedure CMRestoreAll( var Msg:TMessage);virtual cm_First+cm_RestoreAll;
  procedure ODButtonD(var Msg:TMessage);virtual wm_User+um_ButtonD;
  procedure ODButtonU(var Msg:TMessage);virtual wm_User+um_ButtonU;
  procedure GetThumbNail(var ThumbNailRect:TRect);
  procedure RetitleKids;
  procedure WMNCRButtonUp(var Msg:TMessage);virtual wm_First+wm_NCRButtonUp;
end;

PUCChild = ^TUCChild;
TUCChild = OBJECT(TWindow)
	CO:PClipObj;
  IsActive:Boolean;
  SR:TRect;
	constructor Init(AParent:PWindowsObject;ATitle:PChar;SRx:TRect);
  function GetClassName : PChar; Virtual;
  procedure GetWindowClass(var AWndClass: TWndClass);Virtual;
  destructor Done;virtual;
  procedure SetupWindow;virtual;
  procedure Paint(PaintDC:HDC;var PaintInfo:TPaintStruct);virtual;
  procedure UMCopy(var Msg:TMessage);virtual WM_USER+UM_COPY;
  procedure UMDelete(var Msg:TMessage);virtual WM_USER+UM_DELETE;
  procedure WMNCRButtonUp(var Msg:TMessage);virtual wm_First+wm_NCRButtonUp;
  procedure WMPaletteChanged(var Msg:TMessage);virtual wm_First+wm_PaletteChanged;
  procedure WMMDIActivate(var Msg:TMessage);virtual wm_First+wm_MDIActivate;
  procedure UMGetSelf(var Msg:TMessage);virtual wm_User+um_GetSelf;
  procedure WMSize(var Msg:TMessage);virtual wm_First+wm_Size;
  procedure WMRButtonUp(var Msg:TMessage);virtual wm_First+wm_RButtonUp;
end;

PUCAbout = ^TUCAbout;
TUCAbout = object(TDialog)
	procedure WMCtlColor(var Msg:TMessage);virtual wm_First+wm_CtlColor;
end;
{***********************  TUCApp  **************************}
procedure TUCApp.InitMainWindow;
begin
  MainWindow := New(PUCWin, Init('UltraClip',LoadMenu(HInstance, 'UC_Menu')));
end;
{***********************  TUCWin  ***********************************}
constructor TUCWin.Init(ATitle : PChar;AMenu : HMenu);
const
	BMP:Array[0..6] of PChar = ('','Btn1','Btn2','Btn3','Btn4','Btn5','Btn6');
var
	Indx:Integer;
  LFont : TLogFont;
  TNS:Integer;
begin
	TMDIWindow.Init(ATitle, AMenu);
  ChildMenuPos := id_ChildMenuPos;
  IsAutoPaste := False;
  NextViewer := 0;
  For Indx := 0 to 6 do BN[Indx] := nil;
	For Indx := 1 to 6 do
  	BN[Indx]:=New(PUCBtn,Init(@Self,300+Indx,'',
		Pred(Indx)*32,32,32,32,False,BMP[Indx],nil));
  St1 := New(PUCStatic,Init(@Self,id_St1,'',210,5,250,23,sr_Recessed,
			dt_Left or dt_VCenter or dt_SingleLine));
  IsAutoPaste := Bool(GetPrivateProfileInt(AppName,'AutoPaste',0,INIFILE));
  TNS := GetPrivateProfileInt(AppName,'ThumbNailSize',125,INIFILE);
  SetRect(ThumbNailSize,0,0,TNS,TNS);
	StrCopy(Help,'');
  GetObject(GetStockObject(System_Font),sizeof(TLogFont),@LFont);
  StrCopy(LFont.lfFaceName,'Helv');
	LFont.lfHeight := round(LFont.lfHeight * 2 / 3);
  LFont.lfWidth := 0;
  LFont.lfPitchAndFamily := 0;
  Helv := CreateFontIndirect(LFont);
end;

procedure TUCWin.SetUpWindow;
var
	GlobMem:LongInt;
  Title:Array[0..25] of Char;
  SysMenu:HMenu;
  Mssg:PChar;
  Msg:TMessage;
begin
  TMDIWindow.SetUpWindow;
  SetTimer(HWindow,id_Timer,5000,nil);
	GlobMem := GetFreeSpace(0);
  GlobMem := GlobMem div 1024 div 1024;
	wvsprintf(Title,'UltraClip: %li MB Free',GlobMem);
  SetWindowText(HWindow,Title);
  Mssg := 'Start AutoPaste';
  ModifyMenu(Attr.Menu,cm_AutoPaste,mf_ByCommand+mf_String,
           cm_AutoPaste,Mssg);
  Sysmenu := GetSystemMenu(hWindow,false);
  AppendMenu(SysMenu,MF_Separator,0,nil);
	AppendMenu(Sysmenu,0,idm_About,'About');
  DispInfo;
	St1^.SetFont(Helv);
  if IsAutoPaste then
  	begin
    IsAutoPaste := False;
    CMAutoPaste(Msg);
    end;
end;

destructor TUCWin.Done;
begin
	if IsAutoPaste then
  	if NextViewer > 0 then
    ChangeClipboardChain(HWindow,NextViewer);
  KillTimer(HWindow,id_Timer);
  DeleteObject(Helv);
	TMDIWindow.Done;
end;

function TUCWin.GetClassName;
begin
    GetClassName := AppName;
end;

procedure TUCWin.GetWindowClass(VAR AWndClass :TWndClass);
begin
  TMDIWindow.GetWindowClass(AWndClass);
  AWndClass.hIcon := LoadIcon(HInstance, 'UC_Icon');
end;

procedure TUCWin.InitClientWindow;
begin
  TMDIWindow.InitClientWindow;
  WITH ClientWnd^.Attr DO
    Style := Style or WS_VScroll or WS_HScroll;
end;

function TUCWin.InitChild : PWindowsObject;
begin
  InitChild := New(PUCChild, Init(@Self, 'Baby',ThumbNailSize));
end;

procedure TUCWin.CMCut(var Msg:TMessage);
var
	TopWin:HWnd;
begin
	TopWin :=GetTopwindow(ClientWnd^.HWindow);
  if TopWin > 0 then SendMessage(TopWin,WM_User+UM_Copy,0,0);
  if TopWin > 0 then SendMessage(TopWin,WM_User+UM_Delete,0,0);
end;

procedure TUCWin.CMCopy(var Msg:TMessage);
var
	TopWin:HWnd;
begin
	TopWin :=GetTopwindow(ClientWnd^.HWindow);
  if Topwin > 0 then SendMessage(Topwin,WM_User+UM_Copy,0,0);
end;

procedure TUCWin.CMPaste(var Msg:TMessage);
var
  W:PUCChild;
begin
  W := nil;
	if IsClipboardFormatAvailable(cf_DIB) or
		IsClipBoardFormatAvailable(cf_Bitmap) or
		IsClipBoardFormatAvailable(cf_MetaFilePict) or
		IsClipBoardFormatAvailable(cf_Text) then
    	begin
  		W :=PUCChild(Application^.MakeWindow(New(PUCChild,
				Init(@Self,' ',ThumbNailSize ))));
      ShowWindow(W^.HWindow,SW_ShowNoActivate);
      EnableWindow(W^.HWindow,True);
      end;
  if W <> nil then
		If W^.CO = nil then
			W^.CloseWindow
		else
  		 RetitleKids;
end;

procedure TUCWin.CMDelete(var Msg:TMessage);
var TopWin:HWnd;
begin
	TopWin:=GetTopWindow(ClientWnd^.HWindow);
  if TopWin > 0 then
  	SendMessage(TopWin,WM_User+UM_Delete,0,0);
end;

procedure TUCWin.CMAutoPaste(var Msg:TMessage);
begin
	if not IsAutoPaste then
  	begin
    IsAutoPaste := True;
    NextViewer := SetClipboardViewer(HWindow);
    ModifyMenu(Attr.Menu,cm_AutoPaste,mf_ByCommand+mf_String,
           cm_AutoPaste,'Stop AutoPaste');
    end
	else
		begin
		ChangeClipboardChain(HWindow,NextViewer);
    IsAutoPaste := false;
    NextViewer := 0;
    ModifyMenu(Attr.Menu,cm_AutoPaste,mf_ByCommand+mf_String,
           cm_AutoPaste,'Start AutoPaste');
    end;
    DrawMenuBar(HWindow);
  DispInfo;
end;

procedure TUCWin.CMClipClear(var Msg:TMessage);
begin
	OpenClipboard(hWindow);
  EmptyClipboard;
  Closeclipboard;
end;

procedure TUCWin.CMRunCB(var Msg:TMessage);
begin
	WinExec('clipbrd.exe',sw_ShowNormal);
end;

procedure TUCWin.CMConfigure(var Msg:TMessage);
var
	TheDialog:PDialog;
	TfB :Record
  	RB1,RB2:Bool;
    EC1:Array[0..4] of Char;
  end;
  RBut1,RBut2:PRadioButton;
  ECtl1:PEdit;
  FontBut:PButton;
  TNS,Error:Integer;
begin
	TheDialog :=New(PDialog,Init(@Self,'UC_Dlg1'));
  New(RBut1,InitResource(TheDialog,id_D1RB1));
  New(RBut2,InitResource(TheDialog,id_D1RB2));
  New(ECtl1,InitResource(TheDialog,id_D1EC1,5));
  TfB.RB1 := False;TfB.RB2 := False;
  Str(ThumbnailSize.Right,TfB.EC1);
  if IsAutoPaste then TfB.RB1 := True else TfB.RB2 := True;
  TheDialog^.TransferBuffer := @TfB;
  Application^.ExecDialog(TheDialog);
  If TfB.RB1 then
    WritePrivateProfileString(AppName,'AutoPaste','1',IniFile)
  else
    WritePrivateProfileString(Appname,'AutoPaste','0',IniFile);
  WritePrivateProfileString(Appname,'ThumbNailSize',TfB.EC1,IniFile);
  Val(TfB.EC1,TNS,Error);
  SetRect(ThumbNailSize,0,0,TNS,TNS);
end;

procedure TUCWin.WMChangeCBChain(var Msg:TMessage);
begin
	if Msg.wParam = NextViewer then
  	begin
    NextViewer := Msg.lParamLo;
    SendMessage(NextViewer,wm_ChangeCBChain,Msg.wParam,Msg.lParam);
    end;
end;

procedure TUCWin.WMDrawClipBoard(var Msg:TMessage);
var
	ClipOwner :HWnd;
  IsItOurs:Bool;
  procedure IsKid(Child:PWindowsObject);far;
  begin
  	if Child^.HWindow = ClipOwner then IsItOurs := True;
  end;
begin
  ClipOwner := GetClipboardOwner; IsItOurs := False;
  ForEach(@IsKid);
  if not IsItOurs then
  	CMPaste(Msg);
  if NextViewer <> 0 then	
  	SendMessage(NextViewer,wm_DrawClipboard,Msg.wParam,Msg.lParam);
end;

procedure TUCWin.WMTimer(var Msg:TMessage);
var
	GlobMem:LongInt;
  Title:Array[0..25] of Char;
begin
	GlobMem := GetFreeSpace(0);
  GlobMem := GlobMem div 1024 div 1024;
  wvsprintf(Title,'UltraClip: %li MB Free',GlobMem);
  SetWindowText(HWindow,Title);
end;

procedure TUCWin.UMChildExit(var Msg:TMessage);
begin
  RetitleKids;
  DispInfo;
end;

procedure TUCWin.UMChildFocus(var Msg:TMessage);
begin
	DispInfo;
end;

procedure TUCWin.WMPaletteChanged(var Msg:TMessage);
var
	IsChild:Boolean;
  Ret:LongRec;
  procedure IsKid(Child:PWindowsObject);far;
  begin
    if Child^.HWindow = Msg.wParam
    	then IsChild := True;
  end;
begin
	IsChild := False;
  ForEach(@IsKid);
	if not IsChild then
  	InvalidateRect(HWindow,nil,false);
end;

procedure TUCWin.WMQueryNewPalette(var Msg:TMessage);
begin
  InvalidateRect(HWindow,nil,false);
end;

procedure TUCWin.WMSize(var Msg:TMessage);
var
	Indx:Integer;
  CR:TRect;
begin
	GetClientRect(HWindow,CR);
	if (ClientWnd <> nil) and (ClientWnd^.HWindow <> 0) then
		MoveWindow(ClientWnd^.HWindow,0,32,Msg.lParamLo,Msg.LParamHi-32,True);
  for Indx := 1 to 6 do
  	begin
    if (BN[Indx] <> nil) and (BN[Indx]^.HWindow <> 0) then
    	MoveWindow(BN[Indx]^.HWindow,(Indx-1)*33,0,32,32,True);
    end;
  If (ST1 <> nil) and (ST1^.HWindow <> 0) then
  	ST1^.MoveWin(210,5,Cr.Right-220,23);
  CR.Bottom := 32;
  InvalidateRect(HWindow,@CR,True);
end;

procedure	TUCWin.WMDrawItem(var Msg:TMessage);
var
	PDIS : ^TDrawItemStruct;
begin
	PDIS := Pointer(Msg.lParam);
	case PDIS^.CtlType of
		odt_Button:
		case PDIS^.CtlID of
			id_But1..id_But6:Bn[PDIS^.CtlID-Pred(id_But1)]^.DrawItem(Msg);
		end;
	end;
end;

procedure TUCWin.UMRButtonDown(var Msg:TMessage);
begin
	if Msg.wParam <> id_ST1 then EXIT;
	CMAutoPaste(Msg);
	DispInfo;
end;

procedure TUCWin.DispInfo;
type
  ORec = Record
  	AutoP:PChar;
    Info:PChar;
  end;
var
	ChildWin:HWnd;
	Child:PUCChild;
  Size:LongInt;
  Mssg,Stats:Array[0..100] of Char;
  O    :ORec;
begin
	fillchar(O,sizeOf(ORec),0);Child := nil;ChildWin := 0;
	StrCopy(Stats,'');
  if StrLen(Help) > 0 then
  	begin
  	St1^.SetText(Help);
    Exit;
    end;
  if IsAutoPaste then
  	O.AutoP := 'P'
  else
  	O.AutoP := '_';
  ChildWin :=GetTopWindow(ClientWnd^.HWindow);
  if ChildWin <> 0 then
  	begin
    Child := PUCChild(GetObjectPtr(ChildWin));
    if Child <> nil then
  	if Child^.CO <> nil then
  		begin
      Child^.CO^.GetInfo(Stats,sizeof(Stats));
    	O.Info := Stats;
      end;
    end;
	wvsprintf(Mssg,'%s  %s',O);
	ST1^.SetText(Mssg);
	InvalidateRect(ST1^.HWindow,nil,false);
end;

procedure TUCWin.Paint(PaintDC:HDC;var PaintInfo:TPaintStruct);
var
	ob:HBrush;
  CR:TRect;
begin
	GetClientRect(HWindow,CR);
	ob:=SelectObject(PaintDC,GetStockObject(ltGray_Brush));
	Rectangle(PaintDC,0,0,CR.Right,32);
end;

procedure TUCWin.IDBut1(var Msg:TMessage);
begin
	CMCut(Msg);
end;

procedure TUCWin.IDBut2(var Msg:TMessage);
begin
	CMCopy(Msg);
end;

procedure TUCWin.IDBut3(var Msg:TMessage);
begin
	CMPaste(Msg);
end;

procedure TUCWin.IDBut4(var Msg:TMessage);
begin
	CMDelete(Msg);
end;

procedure TUCWin.IDBut5(var Msg:TMessage);
begin
	CMClipClear(Msg);
end;

procedure TUCWin.IDBut6(var Msg:TMessage);
begin
	SendMessage(HWindow,wm_Command,cm_TileChildren,0); 
end;

procedure	TUCWin.WMSysCommand(var Msg:TMessage);
begin
	case Msg.Wparam of
		idm_About:
 			Application^.ExecDialog(New(PUCAbout,Init(@Self,'UC_About')));
    idm_ClipBoard:
    	WinExec('clipbrd.exe',sw_ShowNormal);
   	else
   		DefWndProc(Msg);
   	end;
end;

procedure TUCWin.CMIconAll(var Msg:TMessage);
  procedure ShrinkKids(Child:PWindowsObject);far;
  begin
  	If not(Child^.IsFlagSet(wb_MDIChild)) then Exit;
    If Child^.HWindow = 0 then EXIT;
    ShowWindow(Child^.HWindow,sw_Minimize);
		end;
begin
	ForEach(@ShrinkKids);
end;

procedure TUCWin.CMRestoreAll(var Msg:TMessage);
  procedure RestoreKids(Child:PWindowsObject);far;
  begin
  	If not(Child^.IsFlagSet(wb_MDIChild)) then Exit;
    If Child^.HWindow = 0 then EXIT;
    ShowWindow(Child^.HWindow,sw_Normal);
		end;
begin
	ForEach(@RestoreKids);
end;
	
procedure TUCWin.ODButtonD(var Msg:TMessage);
begin
  case Msg.wParam of
		id_But1:StrCopy(Help,'Cut window to clipboard');
    id_But2:StrCopy(Help,'Copy window to clipboard');
    id_But3:StrCopy(Help,'Paste clipboard to new window');
    id_But4:StrCopy(Help,'Delete active window');
    id_But5:StrCopy(Help,'Erase clipboard contents');
    id_But6:StrCopy(Help,'Tile open windows');
    else StrCopy(Help,'xxx');
    end;
	DispInfo;
end;

procedure TUCWin.ODButtonU(var Msg:TMessage);
begin
	StrCopy(Help,'');
	DispInfo;
end;

procedure TUCWin.GetThumbNail(var ThumbNailRect:TRect);
begin
	ThumbNailRect:=ThumbNailSize;
end;

procedure TUCWin.RetitleKids;
var
  Kids:Array[0..5] of Char;
  Title:Array[0..25] of Char;
  Buf:Array[0..5] of Char;
  pKids : PChar;
  cKids:Word;
  procedure CountChildren(Child:PUCChild);far;
  begin
  	if not(Child^.IsFlagSet(wb_MDIChild)) then Exit;
	  Str(cKids,Kids);
    Child^.Co^.GetFormats(Buf);
  	wvsprintf(Title,'Clip:%s',pKids);
    StrCat(Title,Buf);
    SetWindowText(Child^.HWindow,Title);
    Inc(cKids);
  end;
begin
	cKids := 1;
  pKids := Kids;
	ForEach(@CountChildren);
end;

procedure TUCWin.WMNCRButtonUp(var Msg:TMessage);
begin
	CMConfigure(Msg);
end;
{***********************  TUCChild  ***********************************}
constructor TUCChild.Init(AParent:PWindowsObject;ATitle:PChar;SRx:TRect);
var Stat:Word;
begin
	TWindow.Init(AParent,ATitle);
  SR:=SRx;
  Attr.Style := Attr.Style or ws_Disabled;

end;

procedure TUCChild.SetupWindow;
var
	CR:TRect;
  tb:TBitmap;
  Stat:Word;
begin
	TWindow.SetupWindow;
  GetClientRect(PMDIWindow(Parent)^.ClientWnd^.HWindow,CR);
	InflateRect(CR, -(CR.Right div 20), -(CR.Bottom div 20));
  SetWindowPos(HWindow,HWND_BOTTOM,0,0,CR.Right,CR.Bottom,swp_NoActivate );
	CO :=New(PClipObj,Init(HWindow,Stat,SR));
  if Stat <> st_OK then
    MessageBox(Parent^.HWindow,'Error Pasting from Clipboard ',
    	'UltraClip Alert',mb_systemmodal or mb_iconExclamation)
  else
  	IsActive := True;
end;

procedure TUCChild.Paint(PaintDC:HDC;var PaintInfo:TPaintStruct);
var
	oc:HCursor;
begin
	if CO = nil then Exit; 
  oc := SetCursor(LoadCursor(0,IDC_WAIT));
  if IsActive then	
  	CO^.RenderSelf(PaintDC,HWindow)
 	else
		CO^.RedrawSelf(PaintDC,HWindow);
  SetCursor(oc);
end;

destructor TUCChild.Done;
begin
	if CO <> nil then Dispose(CO,Done);
  if Parent^.HWindow <> 0 then	
  	PostMessage(Parent^.HWindow,wm_User+um_ChildExit,0,0);
  TWindow.Done;
end;

function TUCChild.GetClassName;
begin
  GetClassName := ChdName;
end;

procedure TUCChild.GetWindowClass(VAR AWndClass:TWndClass);
begin
  TWindow.GetWindowClass(AWndClass);
  AWndClass.hIcon := LoadIcon(HInstance, 'UC_IconC');
  AWndClass.hBrBackground := GetStockObject(ltGray_Brush);
end;

procedure TUCChild.UMCopy(var Msg:TMessage);
begin
	if CO <> nil then
		CO^.CopyClip(HWindow);
end;

procedure TUCChild.UMDelete(var Msg:TMessage);
begin
	CloseWindow;
end;

procedure TUCChild.WMNCRButtonUp(var Msg:TMessage);
begin
	SetFocus(HWindow);
  InvalidateRect(HWindow,nil,false);
	PostMessage(HWindow,wm_User+um_Copy,Msg.wParam,Msg.lParam);
end;

procedure TUCChild.WMPaletteChanged(var Msg:TMessage);
var
	DC:HDC;
begin
	if Msg.wParam <> HWindow then
  	if IsActive then
  		begin
    	GetDC(HWindow);
    	CO^.RenderSelf(DC,HWindow);
    	ReleaseDC(HWindow,DC);
    	end;
end;

procedure TUCChild.WMMDIActivate(var Msg:TMessage);
var
	DC:HDC;
begin
	IsActive := Bool(Msg.wParam);
  if IsActive then
  	begin
		InvalidateRect(HWindow,nil,True);
		PostMessage(Parent^.HWindow,wm_User+um_ChildFocus,0,LongInt(@Self));
    end;
end;

procedure TUCChild.UMGetSelf(var Msg:TMessage);
begin
	Msg.Result := LongInt(@Self);
end;

procedure TUCChild.WMSize(var Msg:TMessage);
begin
	if (Msg.wParam <> size_MaxHide) and (Msg.wParam <> size_MaxShow)
	  and IsActive then
			PostMessage(Parent^.HWindow,wm_User+um_ChildFocus,0,LongInt(@Self));
  DefWndProc(Msg);
end;

procedure TUCChild.WMRButtonUp(var Msg:TMessage);
begin
	CO^.ToggleIsPrefText;
  InvalidateRect(HWindow,nil,True);
end;

{************************   TUCBtn  *********************************}
constructor	TUCBtn.Init(AParent:PWindowsObject; AnID:Integer;ATitle:PChar;
  	X1,Y1,W1,H1:Integer;IsDefault:Boolean;BMP:PChar;AGroup:PGroupBox);
begin
	TODButton.Init(AParent,AnID,ATitle,X1,Y1,W1,H1,IsDefault,BMP,AGroup);
  SetFlags(wb_MDIChild,False);
  DefaultProc := @DefWindowProc;
end;

procedure TUCBtn.WMRButtonDown(var Msg:TMessage);
begin
  SendMessage(Parent^.HWindow,wm_User+um_ButtonD,GetID,0);
end;

procedure TUCBtn.WMRButtonUp(var Msg:TMessage);
begin
  SendMessage(Parent^.HWindow,wm_User+um_ButtonU,GetID,0);
end;

{***********************  TUCStatic  ********************************}
constructor TUCStatic.Init(AParent:PWindowsObject;AnID:Integer; ATitle:PChar;
  	NewX,NewY,NewW,NewH:Integer; NewState,NewStyle:Integer);
begin
	TSText.Init(AParent,AnID, ATitle,NewX,NewY,NewW,NewH,NewState,NewStyle);
  SetFlags(wb_MDIChild,False);
  DefaultProc := @DefWindowProc;
end;

procedure TUCStatic.WMRButtonDown(var Msg:TMessage);
begin
  SendMessage(Parent^.HWindow,wm_User+wm_RButtonDown,GetID,0);
end;

{**********************  TUCAbout  ********************************}
procedure TUCAbout.WMCTLCOLOR(var Msg: TMessage);
begin
  case Msg.LParamHi of
    ctlColor_Static,ctlcolor_Dlg:
      begin
      SetBkMode(Msg.WParam, Transparent);
      Msg.Result := GetStockObject(ltGray_Brush);
      end;
  else
    DefWndProc(Msg);
  end;
end;

{***********************   Main Line  **********************************}
var
	TheApp: TUCApp;
begin
  TheApp.Init(AppName);
  TheApp.Run;
  TheApp.Done;
end.
